///////////////////////////////////////////////////////////////////////////////
//Standard-Map mit Möglichkeit zum zoomen und einzelne Trajektorien zu erzeugen
//Gewählte Darstellung: Polarkoordinaten  SxR
//Es wurden so weit wie möglich double Attribute verwendet, um bei relativ 
//großer Anzahl der Iterationen noch rationale Rotationszahlen als 
//diskontinuierlich sehen zu können
////////////////////////////////////////////////////////////////////////////////

//Bildausschnitt zu Beginn: 
double aU = 0;   double aO = 2*Math.PI; //Winkelbereich
double rU = 0  ; double rO = 10; //Radiusbereich
double A,B; //Differenzen in x und y zum aktuellen Mittelpunkt
double  aUNeu, aONeu, rUNeu, rONeu,aAlt, rAlt, aNeu, rNeu;
double  aH, rH; //Startpunkte in Polarkoordinaten
PFont font;
double w = 600; double h = 600; 
double dw =0; double dh =0;//Verschiebung des Mittelpunktes in Pixel (kartesisch!)
double wx,hy; //aktueller Mittelpunkt in Pixel (kartesisch!)
double aK, rK; //Poloar-Koordinaten der Punkte
int n, i, l, L, M; //Erläuterung im setup()
int f; //für die Farbe
double faktor; //für Vergrößerung
double R,r,phi; //Polarkoordinaten
double K;
boolean zeichnen, trajektZeichnen, schonTransparent, ersterPunkt;
PImage bild;
///////////////////////////////////////////////////////////////////////////

void setup(){ 
  size(600, 600);
  background(0); 
  fill(255);
  smooth();
  textSize(16);
  //K=0.0001;////K=0; //K = 0.5;//K = 0.45;//K=1.4; //K=2.5;//K=3.5;//K=4.9976;
  K = 0.971635; //dieser Parameter der Map: Rotationszahl ist goldener Schnitt
  wx = w/2 +dw;
  hy = h/2 +dh;
  A=0; B=0;
  r=0; phi =0; R=0;
  text("K = "+K, 20, 20);
  n= 10000;  //n...Anzahl der Iterationen
  L =100; //L Zufallsstartpunkte
  l = 0; //zählt die Zufallspunkte
  M = 100000; //Anzahl der Punkte auf einer ausgewählten Trajektorie
  aUNeu = aU; aONeu = aO;//Winkelbereich
  rUNeu = rU; rONeu = rO;//Bereich des Radius
  println("K = "+K,"aU = "+aUNeu,"aO = "+aONeu,"rU = "+rUNeu,"rO = "+rONeu);
 
  faktor =0.25;//Zoomfaktor
  zeichnen = true;
  trajektZeichnen = false;
  schonTransparent = false;
  
  bild = createImage(width,height,RGB);
  strokeWeight(1);
}
 
 void draw(){//Maps mit variierendem Parameter K zeichnen
   if(zeichnen){
     //zufällige Startpunkte  
     aH = random((float)aUNeu,(float)aONeu);    
     rH = random((float)rUNeu,(float)rONeu); 
     //rH = 2*Math.PI/8;strokeWeight(2);  //um für einzelne rationale Drehzahlen die Punkte zu zeichnen
     rK = rH*100*faktor; 
     point((float)(rK*Math.cos(aH)+wx),(float)(hy-rK*Math.sin(aH)));    
     iteriere(aH,rH,n,K);     
     if(l<L){
      l++;  
     }
     if(l>=L && !trajektZeichnen){   
       zeichnen = false;        
       tint(255,20);//aktiviert:Bild wird teiltransparent, um die Trajektoerie besser zu sehen
     } 
   }  
 }
//Aus gegebenem Startpunkt (aH,rH) die folgenden n Punkte berechnen
////////////////////////////////////////////////////////
void iteriere(double aH, double rH, int N ,double K){  
  colorMode(HSB,256,256,256);  
  stroke(color(f%256,255,255)); 
  i=0;
  this.K =K;
  aAlt = aH; 
  rAlt = rH;
  n =   N;
  //int zaehlen = 0;//Zur Kontrolle, ob rK >=0
  while(i <=n){  
       rNeu = rAlt + K*Math.sin(aAlt); 
       aNeu = (aAlt + rNeu) % (2*Math.PI);  
       rK = rNeu*100*faktor;
       if(rK <0) {rK = 0; }// println(rK);//Zur Kontrolle, ob rK >=0     
       point((float)(rK*Math.cos(aNeu)+wx),(float)(hy-rK*Math.sin(aNeu)));   
       aAlt = aNeu;
       rAlt = rNeu;
       i++; 
  }
   i=0;  f=f+10;  
}

void mousePressed() { 
  //////////////////////////////////////////////////////////
  //Trajektorie zeichnen
  if(mouseButton == LEFT){
      trajektZeichnen = true;
     // f = f +19;
      if(!schonTransparent){
        image(bild,0,0);  
        schonTransparent = true;
      }   
      i=0;n = 10000;strokeWeight(1);
      //strokeWeight(4);//aktivieren, wenn erster Punkt markiert werden soll
      point(mouseX,mouseY);
      strokeWeight(1);
      A = (mouseX-wx)/100/faktor;
      B = (hy-mouseY)/100/faktor;
      
      
      if((A>= 0 && B>= 0)||(A<= 0 && B>= 0))  {aH =   Math.PI/2-Math.atan(A/B);  rH = B/Math.cos(Math.atan(A/B));}//println(aH,rH);
      if((A<= 0 && B<= 0)||(A>= 0 && B<= 0))  {aH = 3*Math.PI/2-Math.atan(A/B);  rH =-B/Math.cos(Math.atan(A/B));}//println(aH,rH);} 
      l=L-1; 
      zeichnen = true;
      iteriere(aH,rH,n,K); 
      zeichnen = false;
      trajektZeichnen = false;
  }
  
}
/////////////////////////////////////////////////////
void keyPressed() {
  if (key == '+'){//Vergrößern mit Faktor 2
    background(0);
    n=n+n/2;
    L=L+L/4;
    faktor = faktor*2;
    println("Vergrößerung mit Faktor "+faktor);
    l = 0;
    text("K = "+K, 20, 20);
    zeichnen = true;   
  }
  if (key == '-'){//Verkleinern mit Faktor 2
    background(0);
    faktor = faktor/2;
    println("Vergrößerung mit Faktor "+faktor);
    l = 0;
    text("K = "+K, 20, 20);
    zeichnen = true;   
  }  
  if(key == 'r'){//Bild um 100 Pixel nach rechts verschieben
     background(0);
     wx = wx +100;
     l = 0;
     text("K = "+K, 20, 20);
     zeichnen = true;     
  }
  if(key == 'l'){//Bild um 100 Pixel nach links verschieben
     background(0);
     wx = wx -100;
     l = 0;
     text("K = "+K, 20, 20);
     zeichnen = true;     
  }
  if(key == 'u'){//Bild um 100 Pixel nach unten verschieben
     background(0);
     hy = hy +100;
     l = 0;
     text("K = "+K, 20, 20);
     zeichnen = true;     
  }
  if(key == 'o'){//Bild um 100 Pixel nach oben verschieben
     background(0);
     hy = hy -100;
     l = 0;
     text("K = "+K, 20, 20);
     zeichnen = true;     
  }
    if(key == 'p'){//K um 0.05 vergrößern
     background(0);
     K = K+0.05;
     l = 0;
     text("K = "+K, 20, 20);
     zeichnen = true;     
  }
   if(key == 'm'){//K um 0.05 verkleinern
     background(0);
     K = K-0.05;
     l = 0;
     text("K = "+K, 20, 20);
     zeichnen = true;     
  }
}
